import { Observable } from '../data/observable';
var SharedA11YObservable = /** @class */ (function (_super) {
    __extends(SharedA11YObservable, _super);
    function SharedA11YObservable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return SharedA11YObservable;
}(Observable));
export { SharedA11YObservable };
export var AccessibilityServiceEnabledPropName = 'accessibilityServiceEnabled';
var CommonA11YServiceEnabledObservable = /** @class */ (function (_super) {
    __extends(CommonA11YServiceEnabledObservable, _super);
    function CommonA11YServiceEnabledObservable(sharedA11YObservable) {
        var _this = _super.call(this) || this;
        var ref = new WeakRef(_this);
        var lastValue;
        function callback() {
            var self = ref === null || ref === void 0 ? void 0 : ref.get();
            if (!self) {
                sharedA11YObservable.off(Observable.propertyChangeEvent, callback);
                return;
            }
            var newValue = !!sharedA11YObservable.accessibilityServiceEnabled;
            if (newValue !== lastValue) {
                self.set(AccessibilityServiceEnabledPropName, newValue);
                lastValue = newValue;
            }
        }
        sharedA11YObservable.on(Observable.propertyChangeEvent, callback);
        _this.set(AccessibilityServiceEnabledPropName, !!sharedA11YObservable.accessibilityServiceEnabled);
        return _this;
    }
    return CommonA11YServiceEnabledObservable;
}(SharedA11YObservable));
export { CommonA11YServiceEnabledObservable };
//# sourceMappingURL=accessibility-service-common.js.map