import { ColorBase } from './color-common';
var Color = /** @class */ (function (_super) {
    __extends(Color, _super);
    function Color() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(Color.prototype, "ios", {
        get: function () {
            if (!this._ios) {
                // iOS Color is using floating-point values in the [0, 1] range, so divide the components by 255
                this._ios = UIColor.alloc().initWithRedGreenBlueAlpha(this.r / 255, this.g / 255, this.b / 255, this.a / 255);
            }
            return this._ios;
        },
        enumerable: false,
        configurable: true
    });
    Color.fromIosColor = function (value) {
        var r = new interop.Reference();
        var g = new interop.Reference();
        var b = new interop.Reference();
        var a = new interop.Reference();
        value.getRedGreenBlueAlpha(r, g, b, a);
        return new Color(Math.round(a.value * 255), Math.round(r.value * 255), Math.round(g.value * 255), Math.round(b.value * 255));
    };
    return Color;
}(ColorBase));
export { Color };
//# sourceMappingURL=index.ios.js.map