var _allColors = {};
function registerColor(name, value) {
    if (Array.isArray(name)) {
        name.forEach(function (n) { return (_allColors[n.toLowerCase()] = value); });
    }
    else {
        _allColors[name.toLowerCase()] = value;
    }
    return value;
}
export function isKnownName(name) {
    if (!name) {
        return undefined;
    }
    return name.toLowerCase() in _allColors;
}
export function getKnownColor(name) {
    if (!name) {
        return undefined;
    }
    return _allColors[name.toLowerCase()];
}
export var Transparent = registerColor('Transparent', 0x00000000);
export var AliceBlue = registerColor('AliceBlue', 0xfff0f8ff);
export var AntiqueWhite = registerColor('AntiqueWhite', 0xfffaebd7);
export var Aqua = registerColor('Aqua', 0xff00ffff);
export var Aquamarine = registerColor('Aquamarine', 0xff7fffd4);
export var Azure = registerColor('Azure', 0xfff0ffff);
export var Beige = registerColor('Beige', 0xfff5f5dc);
export var Bisque = registerColor('Bisque', 0xffffe4c4);
export var Black = registerColor('Black', 0xff000000);
export var BlanchedAlmond = registerColor('BlanchedAlmond', 0xffffebcd);
export var Blue = registerColor('Blue', 0xff0000ff);
export var BlueViolet = registerColor('BlueViolet', 0xff8a2be2);
export var Brown = registerColor('Brown', 0xffa52a2a);
export var BurlyWood = registerColor('BurlyWood', 0xffdeb887);
export var CadetBlue = registerColor('CadetBlue', 0xff5f9ea0);
export var Chartreuse = registerColor('Chartreuse', 0xff7fff00);
export var Chocolate = registerColor('Chocolate', 0xffd2691e);
export var Coral = registerColor('Coral', 0xffff7f50);
export var CornflowerBlue = registerColor('CornflowerBlue', 0xff6495ed);
export var Cornsilk = registerColor('Cornsilk', 0xfffff8dc);
export var Crimson = registerColor('Crimson', 0xffdc143c);
export var Cyan = registerColor('Cyan', 0xff00ffff);
export var DarkBlue = registerColor('DarkBlue', 0xff00008b);
export var DarkCyan = registerColor('DarkCyan', 0xff008b8b);
export var DarkGoldenRod = registerColor('DarkGoldenRod', 0xffb8860b);
export var DarkGray = registerColor(['DarkGray', 'DarkGrey'], 0xffa9a9a9);
export var DarkGreen = registerColor('DarkGreen', 0xff006400);
export var DarkKhaki = registerColor('DarkKhaki', 0xffbdb76b);
export var DarkMagenta = registerColor('DarkMagenta', 0xff8b008b);
export var DarkOliveGreen = registerColor('DarkOliveGreen', 0xff556b2f);
export var DarkOrange = registerColor('DarkOrange', 0xffff8c00);
export var DarkOrchid = registerColor('DarkOrchid', 0xff9932cc);
export var DarkRed = registerColor('DarkRed', 0xff8b0000);
export var DarkSalmon = registerColor('DarkSalmon', 0xffe9967a);
export var DarkSeaGreen = registerColor('DarkSeaGreen', 0xff8fbc8f);
export var DarkSlateBlue = registerColor('DarkSlateBlue', 0xff483d8b);
export var DarkSlateGray = registerColor(['DarkSlateGray', 'DarkSlateGrey'], 0xff2f4f4f);
export var DarkTurquoise = registerColor('DarkTurquoise', 0xff00ced1);
export var DarkViolet = registerColor('DarkViolet', 0xff9400d3);
export var DeepPink = registerColor('DeepPink', 0xffff1493);
export var DeepSkyBlue = registerColor('DeepSkyBlue', 0xff00bfff);
export var DimGray = registerColor(['DimGray', 'DimGrey'], 0xff696969);
export var DodgerBlue = registerColor('DodgerBlue', 0xff1e90ff);
export var FireBrick = registerColor('FireBrick', 0xffb22222);
export var FloralWhite = registerColor('FloralWhite', 0xfffffaf0);
export var ForestGreen = registerColor('ForestGreen', 0xff228b22);
export var Fuchsia = registerColor('Fuchsia', 0xffff00ff);
export var Gainsboro = registerColor('Gainsboro', 0xffdcdcdc);
export var GhostWhite = registerColor('GhostWhite', 0xfff8f8ff);
export var Gold = registerColor('Gold', 0xffffd700);
export var GoldenRod = registerColor('GoldenRod', 0xffdaa520);
export var Gray = registerColor(['Gray', 'Grey'], 0xff808080);
export var Green = registerColor('Green', 0xff008000);
export var GreenYellow = registerColor('GreenYellow', 0xffadff2f);
export var HoneyDew = registerColor('HoneyDew', 0xfff0fff0);
export var HotPink = registerColor('HotPink', 0xffff69b4);
export var IndianRed = registerColor('IndianRed', 0xffcd5c5c);
export var Indigo = registerColor('Indigo', 0xff4b0082);
export var Ivory = registerColor('Ivory', 0xfffffff0);
export var Khaki = registerColor('Khaki', 0xfff0e68c);
export var Lavender = registerColor('Lavender', 0xffe6e6fa);
export var LavenderBlush = registerColor('LavenderBlush', 0xfffff0f5);
export var LawnGreen = registerColor('LawnGreen', 0xff7cfc00);
export var LemonChiffon = registerColor('LemonChiffon', 0xfffffacd);
export var LightBlue = registerColor('LightBlue', 0xffadd8e6);
export var LightCoral = registerColor('LightCoral', 0xfff08080);
export var LightCyan = registerColor('LightCyan', 0xffe0ffff);
export var LightGoldenRodYellow = registerColor('LightGoldenRodYellow', 0xfffafad2);
export var LightGray = registerColor(['LightGray', 'LightGrey'], 0xffd3d3d3);
export var LightGreen = registerColor('LightGreen', 0xff90ee90);
export var LightPink = registerColor('LightPink', 0xffffb6c1);
export var LightSalmon = registerColor('LightSalmon', 0xffffa07a);
export var LightSeaGreen = registerColor('LightSeaGreen', 0xff20b2aa);
export var LightSkyBlue = registerColor('LightSkyBlue', 0xff87cefa);
export var LightSlateGray = registerColor(['LightSlateGray', 'LightSlateGrey'], 0xff778899);
export var LightSteelBlue = registerColor('LightSteelBlue', 0xffb0c4de);
export var LightYellow = registerColor('LightYellow', 0xffffffe0);
export var Lime = registerColor('Lime', 0xff00ff00);
export var LimeGreen = registerColor('LimeGreen', 0xff32cd32);
export var Linen = registerColor('Linen', 0xfffaf0e6);
export var Magenta = registerColor('Magenta', 0xffff00ff);
export var Maroon = registerColor('Maroon', 0xff800000);
export var MediumAquaMarine = registerColor('MediumAquaMarine', 0xff66cdaa);
export var MediumBlue = registerColor('MediumBlue', 0xff0000cd);
export var MediumOrchid = registerColor('MediumOrchid', 0xffba55d3);
export var MediumPurple = registerColor('MediumPurple', 0xff9370db);
export var MediumSeaGreen = registerColor('MediumSeaGreen', 0xff3cb371);
export var MediumSlateBlue = registerColor('MediumSlateBlue', 0xff7b68ee);
export var MediumSpringGreen = registerColor('MediumSpringGreen', 0xff00fa9a);
export var MediumTurquoise = registerColor('MediumTurquoise', 0xff48d1cc);
export var MediumVioletRed = registerColor('MediumVioletRed', 0xffc71585);
export var MidnightBlue = registerColor('MidnightBlue', 0xff191970);
export var MintCream = registerColor('MintCream', 0xfff5fffa);
export var MistyRose = registerColor('MistyRose', 0xffffe4e1);
export var Moccasin = registerColor('Moccasin', 0xffffe4b5);
export var NavajoWhite = registerColor('NavajoWhite', 0xffffdead);
export var Navy = registerColor('Navy', 0xff000080);
export var OldLace = registerColor('OldLace', 0xfffdf5e6);
export var Olive = registerColor('Olive', 0xff808000);
export var OliveDrab = registerColor('OliveDrab', 0xff6b8e23);
export var Orange = registerColor('Orange', 0xffffa500);
export var OrangeRed = registerColor('OrangeRed', 0xffff4500);
export var Orchid = registerColor('Orchid', 0xffda70d6);
export var PaleGoldenRod = registerColor('PaleGoldenRod', 0xffeee8aa);
export var PaleGreen = registerColor('PaleGreen', 0xff98fb98);
export var PaleTurquoise = registerColor('PaleTurquoise', 0xffafeeee);
export var PaleVioletRed = registerColor('PaleVioletRed', 0xffdb7093);
export var PapayaWhip = registerColor('PapayaWhip', 0xffffefd5);
export var PeachPuff = registerColor('PeachPuff', 0xffffdab9);
export var Peru = registerColor('Peru', 0xffcd853f);
export var Pink = registerColor('Pink', 0xffffc0cb);
export var Plum = registerColor('Plum', 0xffdda0dd);
export var PowderBlue = registerColor('PowderBlue', 0xffb0e0e6);
export var Purple = registerColor('Purple', 0xff800080);
export var RebeccaPurple = registerColor('RebeccaPurple', 0xff663399);
export var Red = registerColor('Red', 0xffff0000);
export var RosyBrown = registerColor('RosyBrown', 0xffbc8f8f);
export var RoyalBlue = registerColor('RoyalBlue', 0xff4169e1);
export var SaddleBrown = registerColor('SaddleBrown', 0xff8b4513);
export var Salmon = registerColor('Salmon', 0xfffa8072);
export var SandyBrown = registerColor('SandyBrown', 0xfff4a460);
export var SeaGreen = registerColor('SeaGreen', 0xff2e8b57);
export var SeaShell = registerColor('SeaShell', 0xfffff5ee);
export var Sienna = registerColor('Sienna', 0xffa0522d);
export var Silver = registerColor('Silver', 0xffc0c0c0);
export var SkyBlue = registerColor('SkyBlue', 0xff87ceeb);
export var SlateBlue = registerColor('SlateBlue', 0xff6a5acd);
export var SlateGray = registerColor(['SlateGray', 'SlateGrey'], 0xff708090);
export var Snow = registerColor('Snow', 0xfffffafa);
export var SpringGreen = registerColor('SpringGreen', 0xff00ff7f);
export var SteelBlue = registerColor('SteelBlue', 0xff4682b4);
export var Tan = registerColor('Tan', 0xffd2b48c);
export var Teal = registerColor('Teal', 0xff008080);
export var Thistle = registerColor('Thistle', 0xffd8bfd8);
export var Tomato = registerColor('Tomato', 0xffff6347);
export var Turquoise = registerColor('Turquoise', 0xff40e0d0);
export var Violet = registerColor('Violet', 0xffee82ee);
export var Wheat = registerColor('Wheat', 0xfff5deb3);
export var White = registerColor('White', 0xffffffff);
export var WhiteSmoke = registerColor('WhiteSmoke', 0xfff5f5f5);
export var Yellow = registerColor('Yellow', 0xffffff00);
export var YellowGreen = registerColor('YellowGreen', 0xff9acd32);
//# sourceMappingURL=known-colors.js.map