import { ImageAssetBase } from './image-asset-common';
import { path as fsPath, knownFolders } from '../file-system';
import { ad } from '../utils';
import { Screen } from '../platform';
export * from './image-asset-common';
var ImageAsset = /** @class */ (function (_super) {
    __extends(ImageAsset, _super);
    function ImageAsset(asset) {
        var _this = _super.call(this) || this;
        var fileName = typeof asset === 'string' ? asset.trim() : '';
        if (fileName.indexOf('~/') === 0) {
            fileName = fsPath.join(knownFolders.currentApp().path, fileName.replace('~/', ''));
        }
        _this.android = fileName;
        return _this;
    }
    Object.defineProperty(ImageAsset.prototype, "android", {
        // @ts-ignore
        get: function () {
            return this._android;
        },
        set: function (value) {
            this._android = value;
        },
        enumerable: false,
        configurable: true
    });
    ImageAsset.prototype.getImageAsync = function (callback) {
        org.nativescript.widgets.Utils.loadImageAsync(ad.getApplicationContext(), this.android, JSON.stringify(this.options || {}), Screen.mainScreen.widthPixels, Screen.mainScreen.heightPixels, new org.nativescript.widgets.Utils.AsyncImageCallback({
            onSuccess: function (bitmap) {
                callback(bitmap, null);
            },
            onError: function (ex) {
                callback(null, ex);
            },
        }));
    };
    return ImageAsset;
}(ImageAssetBase));
export { ImageAsset };
//# sourceMappingURL=index.android.js.map