import { platformNames } from '../common';
var DeviceRef = /** @class */ (function () {
    function DeviceRef() {
    }
    Object.defineProperty(DeviceRef.prototype, "manufacturer", {
        get: function () {
            return 'Apple';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "os", {
        get: function () {
            if (__VISIONOS__) {
                return platformNames.visionos;
            }
            else {
                return platformNames.ios;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "osVersion", {
        get: function () {
            if (!this._osVersion) {
                this._osVersion = UIDevice.currentDevice.systemVersion;
            }
            return this._osVersion;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "model", {
        get: function () {
            if (!this._model) {
                this._model = UIDevice.currentDevice.model;
            }
            return this._model;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "sdkVersion", {
        get: function () {
            if (!this._sdkVersion) {
                this._sdkVersion = UIDevice.currentDevice.systemVersion;
            }
            return this._sdkVersion;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "deviceType", {
        get: function () {
            if (!this._deviceType) {
                if (UIDevice.currentDevice.userInterfaceIdiom === 0 /* UIUserInterfaceIdiom.Phone */) {
                    this._deviceType = 'Phone';
                }
                else if (UIDevice.currentDevice.userInterfaceIdiom === 6 /* UIUserInterfaceIdiom.Vision */) {
                    this._deviceType = 'Tablet';
                    // TODO: could add conditions throughout core for this
                    // this._deviceType = 'Vision';
                }
                else {
                    this._deviceType = 'Tablet';
                }
            }
            return this._deviceType;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "uuid", {
        get: function () {
            var userDefaults = NSUserDefaults.standardUserDefaults;
            var uuid_key = 'TNSUUID';
            var app_uuid = userDefaults.stringForKey(uuid_key);
            if (!app_uuid) {
                app_uuid = NSUUID.UUID().UUIDString;
                userDefaults.setObjectForKey(app_uuid, uuid_key);
                userDefaults.synchronize();
            }
            return app_uuid;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "language", {
        get: function () {
            return NSLocale.preferredLanguages[0];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceRef.prototype, "region", {
        get: function () {
            return NSLocale.currentLocale.objectForKey(NSLocaleCountryCode);
        },
        enumerable: false,
        configurable: true
    });
    return DeviceRef;
}());
export var Device = new DeviceRef();
// This retains compatibility with NS6
export var device = Device;
//# sourceMappingURL=index.ios.js.map