import { ActivityIndicatorBase, busyProperty } from './activity-indicator-common';
import { colorProperty } from '../styling/style-properties';
import { Color } from '../../color';
import { iOSNativeHelper } from '../../utils';
export * from './activity-indicator-common';
var majorVersion = iOSNativeHelper.MajorVersion;
var ActivityIndicator = /** @class */ (function (_super) {
    __extends(ActivityIndicator, _super);
    function ActivityIndicator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._activityIndicatorViewStyle = majorVersion <= 12 || !100 /* UIActivityIndicatorViewStyle.Medium */ ? 2 /* UIActivityIndicatorViewStyle.Gray */ : 100 /* UIActivityIndicatorViewStyle.Medium */;
        return _this;
    }
    ActivityIndicator.prototype.createNativeView = function () {
        var viewStyle = this._activityIndicatorViewStyle;
        var view = UIActivityIndicatorView.alloc().initWithActivityIndicatorStyle(viewStyle);
        view.hidesWhenStopped = true;
        return view;
    };
    Object.defineProperty(ActivityIndicator.prototype, "ios", {
        // @ts-ignore
        get: function () {
            return this.nativeViewProtected;
        },
        enumerable: false,
        configurable: true
    });
    ActivityIndicator.prototype[busyProperty.getDefault] = function () {
        if (this.nativeViewProtected.isAnimating) {
            return this.nativeViewProtected.isAnimating();
        }
        else {
            return this.nativeViewProtected.animating;
        }
    };
    ActivityIndicator.prototype[busyProperty.setNative] = function (value) {
        var nativeView = this.nativeViewProtected;
        if (value) {
            nativeView.startAnimating();
        }
        else {
            nativeView.stopAnimating();
        }
        if (nativeView.hidesWhenStopped) {
            this.requestLayout();
        }
    };
    ActivityIndicator.prototype[colorProperty.getDefault] = function () {
        return this.nativeViewProtected.color;
    };
    ActivityIndicator.prototype[colorProperty.setNative] = function (value) {
        this.nativeViewProtected.color = value instanceof Color ? value.ios : value;
    };
    return ActivityIndicator;
}(ActivityIndicatorBase));
export { ActivityIndicator };
//# sourceMappingURL=index.ios.js.map