import { TextBase } from '../text-base';
import { CSSType } from '../core/view';
import { booleanConverter } from '../core/view-base';
import { AccessibilityRole } from '../../accessibility';
var ButtonBase = /** @class */ (function (_super) {
    __extends(ButtonBase, _super);
    function ButtonBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.accessibilityRole = AccessibilityRole.Button;
        return _this;
    }
    Object.defineProperty(ButtonBase.prototype, "textWrap", {
        get: function () {
            return this.style.whiteSpace === 'normal';
        },
        set: function (value) {
            if (typeof value === 'string') {
                value = booleanConverter(value);
            }
            this.style.whiteSpace = value ? 'normal' : 'nowrap';
        },
        enumerable: false,
        configurable: true
    });
    ButtonBase.tapEvent = 'tap';
    ButtonBase = __decorate([
        CSSType('Button')
    ], ButtonBase);
    return ButtonBase;
}(TextBase));
export { ButtonBase };
ButtonBase.prototype.recycleNativeView = 'auto';
//# sourceMappingURL=button-common.js.map