var ObserverClass = /** @class */ (function (_super) {
    __extends(ObserverClass, _super);
    function ObserverClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ObserverClass.initWithCallback = function (callback) {
        var observer = ObserverClass.alloc().init();
        observer.callback = callback;
        return observer;
    };
    ObserverClass.prototype.observeValueForKeyPathOfObjectChangeContext = function (path, object) {
        var _a;
        var callback = (_a = this.callback) === null || _a === void 0 ? void 0 : _a.deref();
        if (callback) {
            callback(path, object[path]);
        }
    };
    return ObserverClass;
}(NSObject));
var ControlStateChangeListener = /** @class */ (function () {
    function ControlStateChangeListener(control, states, callback) {
        this._observing = false;
        this._control = control;
        this._states = states;
        this._observer = ObserverClass.initWithCallback(new WeakRef(callback));
    }
    ControlStateChangeListener.prototype.start = function () {
        if (!this._observing) {
            this._observing = true;
            for (var _i = 0, _a = this._states; _i < _a.length; _i++) {
                var state = _a[_i];
                this._control.addObserverForKeyPathOptionsContext(this._observer, state, 1 /* NSKeyValueObservingOptions.New */, null);
            }
        }
    };
    ControlStateChangeListener.prototype.stop = function () {
        if (this._observing) {
            for (var _i = 0, _a = this._states; _i < _a.length; _i++) {
                var state = _a[_i];
                this._control.removeObserverForKeyPath(this._observer, state);
            }
            this._observing = false;
        }
    };
    return ControlStateChangeListener;
}());
export { ControlStateChangeListener };
//# sourceMappingURL=index.ios.js.map