import { Color } from '../../../../color';
import { SDK_VERSION } from '../../../../utils/constants';
export * from './view-helper-common';
export var IOSHelper = 0;
var androidxGraphics = androidx.core.graphics;
var AndroidHelper = /** @class */ (function () {
    function AndroidHelper() {
    }
    AndroidHelper.getDrawableColor = function (drawable) {
        if (!drawable) {
            return null;
        }
        var color;
        if (drawable instanceof org.nativescript.widgets.BorderDrawable) {
            color = drawable.getBackgroundColor();
        }
        else if (drawable instanceof android.graphics.drawable.ColorDrawable) {
            color = drawable.getColor();
        }
        else {
            // This is a way to retrieve drawable color when set using color filter
            color = drawable._backgroundColor;
        }
        return new Color(color);
    };
    AndroidHelper.setDrawableColor = function (color, drawable, blendMode) {
        // ColorDrawable is an older class that had support for setColorFilter on API 21
        if (SDK_VERSION < 21 && drawable instanceof android.graphics.drawable.ColorDrawable) {
            drawable.setColor(color);
        }
        else {
            drawable.setColorFilter(androidxGraphics.BlendModeColorFilterCompat.createBlendModeColorFilterCompat(color, blendMode !== null && blendMode !== void 0 ? blendMode : androidxGraphics.BlendModeCompat.SRC_IN));
            // This is a way to retrieve drawable color when set using color filter
            drawable._backgroundColor = color;
        }
    };
    AndroidHelper.clearDrawableColor = function (drawable) {
        // ColorDrawable is an older class that had support for setColorFilter on API 21
        if (SDK_VERSION < 21 && drawable instanceof android.graphics.drawable.ColorDrawable) {
            drawable.setColor(-1);
        }
        else {
            drawable.clearColorFilter();
            // This is a way to retrieve drawable color when set using color filter
            delete drawable._backgroundColor;
        }
    };
    AndroidHelper.getCopyOrDrawable = function (drawable, resources) {
        if (drawable) {
            var constantState = drawable.getConstantState();
            if (constantState) {
                return resources ? constantState.newDrawable(resources) : constantState.newDrawable();
            }
        }
        return drawable;
    };
    return AndroidHelper;
}());
export { AndroidHelper };
//# sourceMappingURL=index.android.js.map