import { View, CSSType } from '../core/view';
import { booleanConverter } from '../core/view-base';
import { Property } from '../core/properties';
var defaultDate = new Date();
var dateComparer = function (x, y) { return x <= y && x >= y; };
var DatePickerBase = /** @class */ (function (_super) {
    __extends(DatePickerBase, _super);
    function DatePickerBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DatePickerBase.dateChangeEvent = 'dateChange';
    DatePickerBase = __decorate([
        CSSType('DatePicker')
    ], DatePickerBase);
    return DatePickerBase;
}(View));
export { DatePickerBase };
DatePickerBase.prototype.recycleNativeView = 'auto';
export var yearProperty = new Property({
    name: 'year',
    defaultValue: defaultDate.getFullYear(),
    valueConverter: function (v) { return parseInt(v); },
});
yearProperty.register(DatePickerBase);
export var monthProperty = new Property({
    name: 'month',
    defaultValue: defaultDate.getMonth() + 1,
    valueConverter: function (v) { return parseInt(v); },
});
monthProperty.register(DatePickerBase);
export var dayProperty = new Property({
    name: 'day',
    defaultValue: defaultDate.getDate(),
    valueConverter: function (v) { return parseInt(v); },
});
dayProperty.register(DatePickerBase);
export var hourProperty = new Property({
    name: 'hour',
    defaultValue: defaultDate.getHours(),
    valueConverter: function (v) { return parseInt(v); },
});
hourProperty.register(DatePickerBase);
export var minuteProperty = new Property({
    name: 'minute',
    defaultValue: defaultDate.getMinutes(),
    valueConverter: function (v) { return parseInt(v); },
});
minuteProperty.register(DatePickerBase);
export var secondProperty = new Property({
    name: 'second',
    defaultValue: defaultDate.getSeconds(),
    valueConverter: function (v) { return parseInt(v); },
});
secondProperty.register(DatePickerBase);
// TODO: Make CoercibleProperties
export var maxDateProperty = new Property({
    name: 'maxDate',
    equalityComparer: dateComparer,
    valueConverter: function (v) { return new Date(v); },
});
maxDateProperty.register(DatePickerBase);
export var minDateProperty = new Property({
    name: 'minDate',
    equalityComparer: dateComparer,
    valueConverter: function (v) { return new Date(v); },
});
minDateProperty.register(DatePickerBase);
export var dateProperty = new Property({
    name: 'date',
    defaultValue: defaultDate,
    equalityComparer: dateComparer,
    valueConverter: function (v) { return new Date(v); },
});
dateProperty.register(DatePickerBase);
export var showTimeProperty = new Property({
    name: 'showTime',
    defaultValue: false,
    valueConverter: function (v) { return booleanConverter(v); },
});
showTimeProperty.register(DatePickerBase);
export var iosPreferredDatePickerStyleProperty = new Property({
    name: 'iosPreferredDatePickerStyle',
    defaultValue: 0,
    valueConverter: function (v) { return parseInt(v); },
});
iosPreferredDatePickerStyleProperty.register(DatePickerBase);
//# sourceMappingURL=date-picker-common.js.map