import { CssProperty } from '../core/properties';
import { View, CSSType } from '../core/view';
import { booleanConverter } from '../core/view-base';
import { Property } from '../core/properties';
import { Style } from '../styling/style';
import { Color } from '../../color';
var HtmlViewBase = /** @class */ (function (_super) {
    __extends(HtmlViewBase, _super);
    function HtmlViewBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtmlViewBase = __decorate([
        CSSType('HtmlView')
    ], HtmlViewBase);
    return HtmlViewBase;
}(View));
export { HtmlViewBase };
HtmlViewBase.prototype.recycleNativeView = 'auto';
// TODO: Can we use Label.ios optimization for affectsLayout???
export var htmlProperty = new Property({
    name: 'html',
    defaultValue: '',
    affectsLayout: true,
});
htmlProperty.register(HtmlViewBase);
export var selectableProperty = new Property({
    name: 'selectable',
    defaultValue: true,
    valueConverter: booleanConverter,
});
selectableProperty.register(HtmlViewBase);
export var linkColorProperty = new CssProperty({
    name: 'linkColor',
    cssName: 'link-color',
    equalityComparer: Color.equals,
    valueConverter: function (value) { return new Color(value); },
});
linkColorProperty.register(Style);
//# sourceMappingURL=html-view-common.js.map