import { TextBase, whiteSpaceProperty } from '../text-base';
import { profile } from '../../profiling';
import { CSSType } from '../core/view';
import { booleanConverter } from '../core/view-base';
export * from '../text-base';
var Label = /** @class */ (function (_super) {
    __extends(Label, _super);
    function Label() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(Label.prototype, "textWrap", {
        get: function () {
            return this.style.whiteSpace === 'normal';
        },
        set: function (value) {
            if (typeof value === 'string') {
                value = booleanConverter(value);
            }
            this.style.whiteSpace = value ? 'normal' : 'nowrap';
        },
        enumerable: false,
        configurable: true
    });
    Label.prototype.createNativeView = function () {
        return new org.nativescript.widgets.StyleableTextView(this._context);
    };
    Label.prototype.initNativeView = function () {
        _super.prototype.initNativeView.call(this);
        var textView = this.nativeTextViewProtected;
        textView.setSingleLine(true);
        textView.setEllipsize(android.text.TextUtils.TruncateAt.END);
        textView.setGravity(android.view.Gravity.CENTER_VERTICAL);
    };
    Label.prototype[whiteSpaceProperty.setNative] = function (value) {
        // Label initial value is no-wrap. set in initNativeView
        var newValue = value === 'initial' ? 'nowrap' : value;
        _super.prototype[whiteSpaceProperty.setNative].call(this, newValue);
    };
    __decorate([
        profile,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Label.prototype, "createNativeView", null);
    Label = __decorate([
        CSSType('Label')
    ], Label);
    return Label;
}(TextBase));
export { Label };
Label.prototype._isSingleLine = true;
Label.prototype.recycleNativeView = 'auto';
//# sourceMappingURL=index.android.js.map