import { LayoutBase } from '../layout-base';
import { CoreTypes } from '../../../core-types';
import { View, CSSType } from '../../core/view';
import { Property } from '../../core/properties';
import { Length } from '../../styling/style-properties';
export * from '../layout-base';
View.prototype.effectiveLeft = 0;
View.prototype.effectiveTop = 0;
function validateArgs(element) {
    if (!element) {
        throw new Error('element cannot be null or undefinied.');
    }
    return element;
}
var AbsoluteLayoutBase = /** @class */ (function (_super) {
    __extends(AbsoluteLayoutBase, _super);
    function AbsoluteLayoutBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // TODO: Do we still need this? it can be get like view.left
    AbsoluteLayoutBase.getLeft = function (element) {
        return validateArgs(element).left;
    };
    // TODO: Do we still need this? it can be set like view.left=value
    AbsoluteLayoutBase.setLeft = function (element, value) {
        validateArgs(element).left = value;
    };
    // TODO: Do we still need this? it can be get like view.top
    AbsoluteLayoutBase.getTop = function (element) {
        return validateArgs(element).top;
    };
    // TODO: Do we still need this? it can be set like view.top=value
    AbsoluteLayoutBase.setTop = function (element, value) {
        validateArgs(element).top = value;
    };
    AbsoluteLayoutBase.prototype.onLeftChanged = function (view, oldValue, newValue) {
        //
    };
    AbsoluteLayoutBase.prototype.onTopChanged = function (view, oldValue, newValue) {
        //
    };
    AbsoluteLayoutBase = __decorate([
        CSSType('AbsoluteLayout')
    ], AbsoluteLayoutBase);
    return AbsoluteLayoutBase;
}(LayoutBase));
export { AbsoluteLayoutBase };
AbsoluteLayoutBase.prototype.recycleNativeView = 'auto';
export var leftProperty = new Property({
    name: 'left',
    defaultValue: CoreTypes.zeroLength,
    valueChanged: function (target, oldValue, newValue) {
        target.effectiveLeft = Length.toDevicePixels(newValue, 0);
        var layout = target.parent;
        if (layout instanceof AbsoluteLayoutBase) {
            layout.onLeftChanged(target, oldValue, newValue);
        }
    },
    valueConverter: function (v) { return Length.parse(v); },
});
leftProperty.register(View);
export var topProperty = new Property({
    name: 'top',
    defaultValue: CoreTypes.zeroLength,
    valueChanged: function (target, oldValue, newValue) {
        target.effectiveTop = Length.toDevicePixels(newValue, 0);
        var layout = target.parent;
        if (layout instanceof AbsoluteLayoutBase) {
            layout.onTopChanged(target, oldValue, newValue);
        }
    },
    valueConverter: function (v) { return Length.parse(v); },
});
topProperty.register(View);
//# sourceMappingURL=absolute-layout-common.js.map