import { CoreTypes } from '../../../core-types';
import { LayoutBase } from '../layout-base';
import { View, CSSType } from '../../core/view';
import { Property, makeValidator, makeParser } from '../../core/properties';
import { booleanConverter } from '../../core/view-base';
function validateArgs(element) {
    if (!element) {
        throw new Error('element cannot be null or undefinied.');
    }
    return element;
}
export * from '../layout-base';
var DockLayoutBase = /** @class */ (function (_super) {
    __extends(DockLayoutBase, _super);
    function DockLayoutBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DockLayoutBase.getDock = function (element) {
        return validateArgs(element).dock;
    };
    DockLayoutBase.setDock = function (element, value) {
        validateArgs(element).dock = value;
    };
    DockLayoutBase.prototype.onDockChanged = function (view, oldValue, newValue) {
        //
    };
    DockLayoutBase = __decorate([
        CSSType('DockLayout')
    ], DockLayoutBase);
    return DockLayoutBase;
}(LayoutBase));
export { DockLayoutBase };
DockLayoutBase.prototype.recycleNativeView = 'auto';
var dockConverter = makeParser(makeValidator(CoreTypes.Dock.left, CoreTypes.Dock.top, CoreTypes.Dock.right, CoreTypes.Dock.bottom));
export var dockProperty = new Property({
    name: 'dock',
    defaultValue: 'left',
    valueChanged: function (target, oldValue, newValue) {
        if (target instanceof View) {
            var layout = target.parent;
            if (layout instanceof DockLayoutBase) {
                layout.onDockChanged(target, oldValue, newValue);
            }
        }
    },
    valueConverter: dockConverter,
});
dockProperty.register(View);
export var stretchLastChildProperty = new Property({
    name: 'stretchLastChild',
    defaultValue: true,
    affectsLayout: __APPLE__,
    valueConverter: booleanConverter,
});
stretchLastChildProperty.register(DockLayoutBase);
//# sourceMappingURL=dock-layout-common.js.map