import { DockLayoutBase, dockProperty, stretchLastChildProperty } from './dock-layout-common';
import { View } from '../../core/view';
export * from './dock-layout-common';
View.prototype[dockProperty.setNative] = function (value) {
    var nativeView = this.nativeViewProtected;
    var lp = nativeView.getLayoutParams() || new org.nativescript.widgets.CommonLayoutParams();
    if (lp instanceof org.nativescript.widgets.CommonLayoutParams) {
        switch (value) {
            case 'left':
                lp.dock = org.nativescript.widgets.Dock.left;
                break;
            case 'top':
                lp.dock = org.nativescript.widgets.Dock.top;
                break;
            case 'right':
                lp.dock = org.nativescript.widgets.Dock.right;
                break;
            case 'bottom':
                lp.dock = org.nativescript.widgets.Dock.bottom;
                break;
            default:
                throw new Error("Invalid value for dock property: ".concat(value));
        }
        nativeView.setLayoutParams(lp);
    }
};
var DockLayout = /** @class */ (function (_super) {
    __extends(DockLayout, _super);
    function DockLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DockLayout.prototype.createNativeView = function () {
        return new org.nativescript.widgets.DockLayout(this._context);
    };
    DockLayout.prototype[stretchLastChildProperty.getDefault] = function () {
        return true;
    };
    DockLayout.prototype[stretchLastChildProperty.setNative] = function (value) {
        this.nativeViewProtected.setStretchLastChild(value);
    };
    return DockLayout;
}(DockLayoutBase));
export { DockLayout };
//# sourceMappingURL=index.android.js.map