import { LayoutBaseCommon, clipToBoundsProperty, isPassThroughParentEnabledProperty } from './layout-base-common';
export * from './layout-base-common';
var LayoutBase = /** @class */ (function (_super) {
    __extends(LayoutBase, _super);
    function LayoutBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LayoutBase.prototype.addChild = function (child) {
        _super.prototype.addChild.call(this, child);
        this.requestLayout();
    };
    LayoutBase.prototype.insertChild = function (child, atIndex) {
        _super.prototype.insertChild.call(this, child, atIndex);
        this.requestLayout();
    };
    LayoutBase.prototype.removeChild = function (child) {
        _super.prototype.removeChild.call(this, child);
        this.requestLayout();
    };
    LayoutBase.prototype._setNativeClipToBounds = function () {
        if (this.clipToBounds) {
            var view = this.nativeViewProtected;
            if (view) {
                view.clipsToBounds = true;
            }
        }
        else {
            _super.prototype._setNativeClipToBounds.call(this);
        }
    };
    LayoutBase.prototype[clipToBoundsProperty.getDefault] = function () {
        return false;
    };
    LayoutBase.prototype[clipToBoundsProperty.setNative] = function (value) {
        this._setNativeClipToBounds();
    };
    LayoutBase.prototype[isPassThroughParentEnabledProperty.setNative] = function (value) {
        this.nativeViewProtected.setPassThroughParent(value);
    };
    return LayoutBase;
}(LayoutBaseCommon));
export { LayoutBase };
//# sourceMappingURL=layout-base.ios.js.map