import { LayoutBase } from '../layout-base';
import { CSSType } from '../../core/view';
import { Property, makeValidator, makeParser } from '../../core/properties';
import { Length } from '../../styling/style-properties';
import { CoreTypes } from '../../../core-types';
export * from '../layout-base';
var WrapLayoutBase = /** @class */ (function (_super) {
    __extends(WrapLayoutBase, _super);
    function WrapLayoutBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WrapLayoutBase = __decorate([
        CSSType('WrapLayout')
    ], WrapLayoutBase);
    return WrapLayoutBase;
}(LayoutBase));
export { WrapLayoutBase };
WrapLayoutBase.prototype.recycleNativeView = 'auto';
export var itemWidthProperty = new Property({
    name: 'itemWidth',
    defaultValue: 'auto',
    affectsLayout: __APPLE__,
    valueConverter: function (v) { return Length.parse(v); },
    valueChanged: function (target, oldValue, newValue) { return (target.effectiveItemWidth = Length.toDevicePixels(newValue, -1)); },
});
itemWidthProperty.register(WrapLayoutBase);
export var itemHeightProperty = new Property({
    name: 'itemHeight',
    defaultValue: 'auto',
    affectsLayout: __APPLE__,
    valueConverter: function (v) { return Length.parse(v); },
    valueChanged: function (target, oldValue, newValue) { return (target.effectiveItemHeight = Length.toDevicePixels(newValue, -1)); },
});
itemHeightProperty.register(WrapLayoutBase);
var converter = makeParser(makeValidator(CoreTypes.Orientation.horizontal, CoreTypes.Orientation.vertical));
export var orientationProperty = new Property({
    name: 'orientation',
    defaultValue: CoreTypes.Orientation.horizontal,
    affectsLayout: __APPLE__,
    valueConverter: converter,
});
orientationProperty.register(WrapLayoutBase);
//# sourceMappingURL=wrap-layout-common.js.map