import { ProgressBase, valueProperty, maxValueProperty } from './progress-common';
import { Color } from '../../color';
import { colorProperty, backgroundColorProperty, backgroundInternalProperty } from '../styling/style-properties';
import { AndroidHelper } from '../core/view';
export * from './progress-common';
var R_ATTR_PROGRESS_BAR_STYLE_HORIZONTAL = 0x01010078;
var Progress = /** @class */ (function (_super) {
    __extends(Progress, _super);
    function Progress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Progress.prototype.createNativeView = function () {
        return new android.widget.ProgressBar(this._context, null, R_ATTR_PROGRESS_BAR_STYLE_HORIZONTAL);
    };
    Progress.prototype[valueProperty.getDefault] = function () {
        return 0;
    };
    Progress.prototype[valueProperty.setNative] = function (value) {
        this.nativeViewProtected.setProgress(value);
    };
    Progress.prototype[maxValueProperty.getDefault] = function () {
        return 100;
    };
    Progress.prototype[maxValueProperty.setNative] = function (value) {
        this.nativeViewProtected.setMax(value);
    };
    Progress.prototype[colorProperty.getDefault] = function () {
        return null;
    };
    Progress.prototype[colorProperty.setNative] = function (value) {
        var progressDrawable = this.nativeViewProtected.getProgressDrawable();
        if (!progressDrawable) {
            return;
        }
        if (value instanceof Color) {
            AndroidHelper.setDrawableColor(value.android, progressDrawable);
        }
        else {
            AndroidHelper.clearDrawableColor(progressDrawable);
        }
    };
    Progress.prototype[backgroundColorProperty.getDefault] = function () {
        return null;
    };
    Progress.prototype[backgroundColorProperty.setNative] = function (value) {
        var progressDrawable = this.nativeViewProtected.getProgressDrawable();
        if (!progressDrawable) {
            return;
        }
        if (progressDrawable instanceof android.graphics.drawable.LayerDrawable && progressDrawable.getNumberOfLayers() > 0) {
            var backgroundDrawable = progressDrawable.getDrawable(0);
            if (backgroundDrawable) {
                if (value instanceof Color) {
                    AndroidHelper.setDrawableColor(value.android, backgroundDrawable);
                }
                else {
                    AndroidHelper.clearDrawableColor(backgroundDrawable);
                }
            }
        }
    };
    Progress.prototype[backgroundInternalProperty.getDefault] = function () {
        return null;
    };
    Progress.prototype[backgroundInternalProperty.setNative] = function (value) {
        //
    };
    return Progress;
}(ProgressBase));
export { Progress };
//# sourceMappingURL=index.android.js.map