import { ProgressBase, valueProperty, maxValueProperty } from './progress-common';
import { Color } from '../../color';
import { colorProperty, backgroundColorProperty, backgroundInternalProperty } from '../styling/style-properties';
export * from './progress-common';
var Progress = /** @class */ (function (_super) {
    __extends(Progress, _super);
    function Progress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Progress.prototype.createNativeView = function () {
        return UIProgressView.new();
    };
    Object.defineProperty(Progress.prototype, "ios", {
        // @ts-ignore
        get: function () {
            return this.nativeViewProtected;
        },
        enumerable: false,
        configurable: true
    });
    Progress.prototype[valueProperty.getDefault] = function () {
        return 0;
    };
    Progress.prototype[valueProperty.setNative] = function (value) {
        this.ios.progress = value / this.maxValue;
    };
    Progress.prototype[maxValueProperty.getDefault] = function () {
        return 100;
    };
    Progress.prototype[maxValueProperty.setNative] = function (value) {
        this.ios.progress = this.value / value;
    };
    Progress.prototype[colorProperty.getDefault] = function () {
        return this.ios.progressTintColor;
    };
    Progress.prototype[colorProperty.setNative] = function (value) {
        this.ios.progressTintColor = value instanceof Color ? value.ios : value;
    };
    Progress.prototype[backgroundColorProperty.getDefault] = function () {
        return this.ios.trackTintColor;
    };
    Progress.prototype[backgroundColorProperty.setNative] = function (value) {
        var color = value instanceof Color ? value.ios : value;
        this.ios.trackTintColor = color;
    };
    Progress.prototype[backgroundInternalProperty.getDefault] = function () {
        return null;
    };
    Progress.prototype[backgroundInternalProperty.setNative] = function (value) {
        //
    };
    return Progress;
}(ProgressBase));
export { Progress };
//# sourceMappingURL=index.ios.js.map