import { View, CSSType } from '../core/view';
import { Property, CoercibleProperty } from '../core/properties';
var ProgressBase = /** @class */ (function (_super) {
    __extends(ProgressBase, _super);
    function ProgressBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProgressBase = __decorate([
        CSSType('Progress')
    ], ProgressBase);
    return ProgressBase;
}(View));
export { ProgressBase };
ProgressBase.prototype.recycleNativeView = 'auto';
/**
 * Represents the observable property backing the value property of each Progress instance.
 */
export var valueProperty = new CoercibleProperty({
    name: 'value',
    defaultValue: 0,
    coerceValue: function (t, v) {
        return v < 0 ? 0 : Math.min(v, t.maxValue);
    },
    valueConverter: function (v) { return parseInt(v); },
});
valueProperty.register(ProgressBase);
/**
 * Represents the observable property backing the maxValue property of each Progress instance.
 */
export var maxValueProperty = new Property({
    name: 'maxValue',
    defaultValue: 100,
    valueChanged: function (target, oldValue, newValue) {
        valueProperty.coerce(target);
    },
    valueConverter: function (v) { return parseInt(v); },
});
maxValueProperty.register(ProgressBase);
//# sourceMappingURL=progress-common.js.map