import { View, CSSType } from '../core/view';
import { Property } from '../core/properties';
import { Color } from '../../color';
var SearchBarBase = /** @class */ (function (_super) {
    __extends(SearchBarBase, _super);
    function SearchBarBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SearchBarBase.submitEvent = 'submit';
    SearchBarBase.clearEvent = 'clear';
    SearchBarBase = __decorate([
        CSSType('SearchBar')
    ], SearchBarBase);
    return SearchBarBase;
}(View));
export { SearchBarBase };
SearchBarBase.prototype.recycleNativeView = 'auto';
export var textProperty = new Property({
    name: 'text',
    defaultValue: '',
    affectsLayout: __APPLE__,
});
textProperty.register(SearchBarBase);
export var hintProperty = new Property({
    name: 'hint',
    defaultValue: '',
});
hintProperty.register(SearchBarBase);
export var textFieldHintColorProperty = new Property({
    name: 'textFieldHintColor',
    equalityComparer: Color.equals,
    valueConverter: function (v) { return new Color(v); },
});
textFieldHintColorProperty.register(SearchBarBase);
export var textFieldBackgroundColorProperty = new Property({
    name: 'textFieldBackgroundColor',
    equalityComparer: Color.equals,
    valueConverter: function (v) { return new Color(v); },
});
textFieldBackgroundColorProperty.register(SearchBarBase);
//# sourceMappingURL=search-bar-common.js.map