import { Color } from '../../color';
import { parseCSSShorthand } from './css-utils';
/**
 * Parse a string into ShadowCSSValues
 * Supports any valid css box/text shadow combination.
 *
 * inspired by https://github.com/jxnblk/css-box-shadow/blob/master/index.js (MIT License)
 *
 * @param value
 */
export function parseCSSShadow(value) {
    var data = parseCSSShorthand(value);
    if (!data) {
        return null;
    }
    var _a = data.values, offsetX = _a[0], offsetY = _a[1], blurRadius = _a[2], spreadRadius = _a[3];
    return {
        inset: data.inset,
        offsetX: offsetX,
        offsetY: offsetY,
        blurRadius: blurRadius,
        spreadRadius: spreadRadius,
        color: data.color ? new Color(data.color) : undefined,
    };
}
//# sourceMappingURL=css-shadow.js.map