import { Color } from '../../color';
import { View, CSSType } from '../core/view';
import { booleanConverter } from '../core/view-base';
import { Property } from '../core/properties';
var SwitchBase = /** @class */ (function (_super) {
    __extends(SwitchBase, _super);
    function SwitchBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SwitchBase.prototype._onCheckedPropertyChanged = function (newValue) {
        if (newValue) {
            this._addVisualState('checked');
        }
        else {
            this._removeVisualState('checked');
        }
    };
    SwitchBase.checkedChangeEvent = 'checkedChange';
    SwitchBase = __decorate([
        CSSType('Switch')
    ], SwitchBase);
    return SwitchBase;
}(View));
export { SwitchBase };
SwitchBase.prototype.recycleNativeView = 'auto';
function onCheckedPropertyChanged(target, oldValue, newValue) {
    target._onCheckedPropertyChanged(newValue);
}
export var checkedProperty = new Property({
    name: 'checked',
    defaultValue: false,
    valueConverter: booleanConverter,
    valueChanged: onCheckedPropertyChanged,
});
checkedProperty.register(SwitchBase);
export var offBackgroundColorProperty = new Property({
    name: 'offBackgroundColor',
    equalityComparer: Color.equals,
    valueConverter: function (v) { return new Color(v); },
});
offBackgroundColorProperty.register(SwitchBase);
//# sourceMappingURL=switch-common.js.map