import { ViewBase } from '../core/view-base';
import { isNullOrUndefined, isString } from '../../utils/types';
var Span = /** @class */ (function (_super) {
    __extends(Span, _super);
    function Span() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._tappable = false;
        return _this;
    }
    Object.defineProperty(Span.prototype, "fontFamily", {
        get: function () {
            return this.style.fontFamily;
        },
        set: function (value) {
            this.style.fontFamily = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "fontSize", {
        get: function () {
            return this.style.fontSize;
        },
        set: function (value) {
            this.style.fontSize = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "fontStyle", {
        // Italic
        get: function () {
            return this.style.fontStyle;
        },
        set: function (value) {
            this.style.fontStyle = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "fontWeight", {
        // Bold
        get: function () {
            return this.style.fontWeight;
        },
        set: function (value) {
            this.style.fontWeight = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "fontVariationSettings", {
        get: function () {
            return this.style.fontVariationSettings;
        },
        set: function (value) {
            this.style.fontVariationSettings = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "textDecoration", {
        get: function () {
            return this.style.textDecoration;
        },
        set: function (value) {
            this.style.textDecoration = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "color", {
        get: function () {
            return this.style.color;
        },
        set: function (value) {
            this.style.color = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "backgroundColor", {
        get: function () {
            return this.style.backgroundColor;
        },
        set: function (value) {
            this.style.backgroundColor = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "iosAccessibilityAdjustsFontSize", {
        get: function () {
            return this.style.iosAccessibilityAdjustsFontSize;
        },
        set: function (value) {
            this.style.iosAccessibilityAdjustsFontSize = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "iosAccessibilityMinFontScale", {
        get: function () {
            return this.style.iosAccessibilityMinFontScale;
        },
        set: function (value) {
            this.style.iosAccessibilityMinFontScale = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "iosAccessibilityMaxFontScale", {
        get: function () {
            return this.style.iosAccessibilityMaxFontScale;
        },
        set: function (value) {
            this.style.iosAccessibilityMaxFontScale = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "text", {
        get: function () {
            return this._text;
        },
        set: function (value) {
            if (this._text !== value) {
                if (isNullOrUndefined(value)) {
                    this._text = '';
                }
                else {
                    // value can be a number
                    this._text = isString(value) ? "".concat(value).replace('\\n', '\n').replace('\\t', '\t') : "".concat(value);
                }
                this.notifyPropertyChange('text', this._text);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Span.prototype, "tappable", {
        get: function () {
            return this._tappable;
        },
        enumerable: false,
        configurable: true
    });
    Span.prototype.addEventListener = function (arg, callback, thisArg) {
        _super.prototype.addEventListener.call(this, arg, callback, thisArg);
        this._setTappable(this.hasListeners(Span.linkTapEvent));
    };
    Span.prototype.removeEventListener = function (arg, callback, thisArg) {
        _super.prototype.removeEventListener.call(this, arg, callback, thisArg);
        this._setTappable(this.hasListeners(Span.linkTapEvent));
    };
    Span.prototype._setTextInternal = function (value) {
        this._text = value;
    };
    Span.prototype._setTappable = function (value) {
        if (this._tappable !== value) {
            this._tappable = value;
            this.notifyPropertyChange('tappable', value);
        }
    };
    Span.linkTapEvent = 'linkTap';
    return Span;
}(ViewBase));
export { Span };
//# sourceMappingURL=span.js.map