import { _resolveAnimationCurve } from '../animation';
import lazy from '../../utils/lazy';
var _defaultInterpolator = lazy(function () { return new android.view.animation.AccelerateDecelerateInterpolator(); });
var transitionId = 0;
var Transition = /** @class */ (function () {
    function Transition(duration, curve) {
        if (duration === void 0) { duration = 350; }
        this._duration = duration;
        this._interpolator = curve ? _resolveAnimationCurve(curve) : _defaultInterpolator();
        transitionId++;
        this.id = transitionId;
    }
    Transition.prototype.getDuration = function () {
        return this._duration;
    };
    Transition.prototype.setDuration = function (value) {
        this._duration = value;
    };
    Transition.prototype.getCurve = function () {
        return this._interpolator;
    };
    Transition.prototype.animateIOSTransition = function (transitionContext, fromViewCtrl, toViewCtrl, operation) {
        throw new Error('Abstract method call');
    };
    Transition.prototype.createAndroidAnimator = function (transitionType) {
        throw new Error('Abstract method call');
    };
    Transition.prototype.toString = function () {
        return "Transition@".concat(this.id);
    };
    Transition.AndroidTransitionType = {
        enter: 'enter',
        exit: 'exit',
        popEnter: 'popEnter',
        popExit: 'popExit',
    };
    return Transition;
}());
export { Transition };
//# sourceMappingURL=index.android.js.map