import { CORE_ANIMATION_DEFAULTS } from '../../utils/common';
var transitionId = 0;
var Transition = /** @class */ (function () {
    function Transition(duration, nativeCurve) {
        if (duration === void 0) { duration = 350; }
        if (nativeCurve === void 0) { nativeCurve = 0 /* UIViewAnimationCurve.EaseInOut */; }
        this._duration = duration ? duration / 1000 : CORE_ANIMATION_DEFAULTS.duration;
        this._curve = nativeCurve;
        transitionId++;
        this.id = transitionId;
    }
    Transition.prototype.getDuration = function () {
        return this._duration;
    };
    Transition.prototype.setDuration = function (value) {
        this._duration = value;
    };
    Transition.prototype.getCurve = function () {
        return this._curve;
    };
    Transition.prototype.animateIOSTransition = function (transitionContext, fromViewCtrl, toViewCtrl, operation) {
        throw new Error('Abstract method call');
    };
    Transition.prototype.createAndroidAnimator = function (transitionType) {
        throw new Error('Abstract method call');
    };
    Transition.prototype.toString = function () {
        return "Transition@".concat(this.id);
    };
    Transition.AndroidTransitionType = {};
    return Transition;
}());
export { Transition };
//# sourceMappingURL=index.ios.js.map