import { knownFolders } from '../file-system';
export var debug = true;
var applicationRootPath;
function ensureAppRootPath() {
    if (!applicationRootPath) {
        applicationRootPath = knownFolders.currentApp().path;
        applicationRootPath = applicationRootPath.substring(0, applicationRootPath.length - 'app/'.length);
    }
}
var Source = /** @class */ (function () {
    function Source(uri, line, column) {
        ensureAppRootPath();
        if (uri.length > applicationRootPath.length && uri.substring(0, applicationRootPath.length) === applicationRootPath) {
            this._uri = 'file://' + uri.substring(applicationRootPath.length);
        }
        else {
            this._uri = uri;
        }
        this._line = line;
        this._column = column;
    }
    Object.defineProperty(Source.prototype, "uri", {
        get: function () {
            return this._uri;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Source.prototype, "line", {
        get: function () {
            return this._line;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Source.prototype, "column", {
        get: function () {
            return this._column;
        },
        enumerable: false,
        configurable: true
    });
    Source.prototype.toString = function () {
        return this._uri + ':' + this._line + ':' + this._column;
    };
    Source.get = function (object) {
        return object[Source._source];
    };
    Source.set = function (object, src) {
        object[Source._source] = src;
    };
    Source._source = Symbol('source');
    return Source;
}());
export { Source };
var ScopeError = /** @class */ (function (_super) {
    __extends(ScopeError, _super);
    function ScopeError(inner, message) {
        var _this = this;
        var formattedMessage;
        if (message && inner.message) {
            formattedMessage = message + '\n > ' + inner.message.replace('\n', '\n  ');
        }
        else {
            formattedMessage = message || inner.message || undefined;
        }
        _this = _super.call(this, formattedMessage) || this;
        _this.stack = __ANDROID__ ? 'Error: ' + _this.message + '\n' + inner.stack.substr(inner.stack.indexOf('\n') + 1) : inner.stack;
        _this.message = formattedMessage;
        return _this;
    }
    return ScopeError;
}(Error));
export { ScopeError };
var SourceError = /** @class */ (function (_super) {
    __extends(SourceError, _super);
    function SourceError(child, source, message) {
        return _super.call(this, child, message ? message + ' @' + source + '' : source + '') || this;
    }
    return SourceError;
}(ScopeError));
export { SourceError };
//# sourceMappingURL=debug.js.map