import { Trace } from '../trace';
import { dispatchToMainThread } from './mainthread-helper';
var scheduled = false;
var macroTaskQueue = [];
function drainMacrotaskQueue() {
    var currentQueue = macroTaskQueue;
    macroTaskQueue = [];
    scheduled = false;
    currentQueue.forEach(function (task) {
        try {
            task();
        }
        catch (err) {
            var msg_1 = err ? err.stack || err : err;
            Trace.write("Error in macroTask: ".concat(msg_1), Trace.categories.Error, Trace.messageType.error);
        }
    });
}
export function queueMacrotask(task) {
    macroTaskQueue.push(task);
    if (!scheduled) {
        scheduled = true;
        dispatchToMainThread(drainMacrotaskQueue);
    }
}
//# sourceMappingURL=macrotask-scheduler.js.map