/**
 * @internal Util used for exporting opposing platform utils and warning the user if they are trying to access them.
 */
export function platformCheck(parent) {
    if (__DEV__) {
        return new Proxy({}, {
            get: function (_, prop) {
                var propPretty = [parent, prop.toString()].join('.');
                var hintPlatformCheck = __ANDROID__ ? '__IOS__' : '__ANDROID__';
                // prettier-ignore
                var errorMsg = [
                    "Trying to access \"".concat(propPretty, "\" without checking platform first."),
                    "Hint: Use \"".concat(hintPlatformCheck, "\" to check platform before accessing \"").concat(propPretty, "\".")
                ].join('\n');
                throw new Error(errorMsg);
            },
        });
    }
    return undefined;
}
//# sourceMappingURL=platform-check.js.map