import { SubtleCrypto } from './SubtleCrypto';
var subtle = new SubtleCrypto();
var Crypto = /** @class */ (function () {
    function Crypto() {
    }
    Object.defineProperty(Crypto.prototype, "subtle", {
        get: function () {
            return subtle;
        },
        enumerable: false,
        configurable: true
    });
    Crypto.prototype.randomUUID = function () {
        if (__ANDROID__) {
            return org.nativescript.winter_tc.Crypto.randomUUID();
        }
        if (__IOS__) {
            return NSCCrypto.randomUUID();
        }
    };
    Crypto.prototype.getRandomValues = function (typedArray) {
        if (__ANDROID__) {
            if (typedArray.BYTES_PER_ELEMENT !== 1) {
                typedArray = new Uint8Array(typedArray.buffer, typedArray.byteOffset);
            }
            org.nativescript.winter_tc.Crypto.getRandomValues(typedArray);
        }
        if (__IOS__) {
            if (typedArray.BYTES_PER_ELEMENT !== 1) {
                typedArray = new Uint8Array(typedArray.buffer, typedArray.byteOffset, typedArray.byteLength);
            }
            var data = NSMutableData.dataWithBytesNoCopyLength(typedArray, typedArray.byteLength);
            NSCCrypto.getRandomValues(data);
        }
        return typedArray;
    };
    return Crypto;
}());
export { Crypto };
//# sourceMappingURL=index.js.map